/*

 ***************************************************************************
 ***************************************************************************
 ***************                                            ****************
 ***************      Testprogramm zur Tenperaturmessung    ****************
 ***************       (Z)opyright by Martinjak & Pippan    ****************
 ***************         Version 2005 erweitert für Siebens.****************
 ***************         23.02.2000 (funktioniert)          ****************
 ***************                                            ****************
 ***************************************************************************
 ***************************************************************************

*/

 #include <stdio.h>
 #include <conio.h>
 #include <dos.h>
 #include <math.h>
 #include <graphics.h>
 #include <stdlib.h>

 #define    ws               8  // ms Waitstate
 #define    basis        0x378  // I/O Portadress
 #define    Data       basis+0
 #define    Status     basis+1
 #define    Control    basis+2

 #define    o                8
 #define    n                9

class INITDS
{
 protected:
	unsigned char out;
	unsigned int bin;
	float  in;
	int a,Vorzeichen;

 public:
	INITDS ();
	~INITDS();

	void Rahmen( int, int, int, int );
	void SetKastl( int, int, unsigned char, int);
	void Kastl( int, int, int );

	void Import_Temperatur ( int, int, int, int );
	void Temperatur_Ausgabe( int, int );
	void Feld_Bin ( unsigned char );
	void Send_Protocol ( int, int, unsigned char, int, int );
	void Write_Port ( unsigned int, unsigned char );
	void LCD_Ausgabe( float );
	void Menu(int , int , char*, int, int );
	float int_to_double( unsigned int );
	void Minusgrade( unsigned int );
};


void main()
{
 INITDS t;
 char wahl;
 char zeichen[80];
 int x=100, y=60;

 //************************* MENU ****************************
 do
 {
  outportb(Data,0xFF);  //INIT Data Port
  outportb(Data,0x00);
  outportb(Status,0x00);//INIT Status Port

 /******  Auswahlmenü (Startbildschirm)  ********/

  cleardevice();
  setcolor( BLUE );
  sprintf  ( zeichen, "Testprogramm zur Temperaturmessung");
  outtextxy( x, y, zeichen );

  sprintf  ( zeichen, "TMS 2000 Version 1.x");
  outtextxy( x+20, y+10, zeichen );

  sprintf  ( zeichen, "(Z)opyright by Martinjak und Pippan");
  outtextxy( x, y+20, zeichen );

  sprintf  ( zeichen, "[R] Lesen der Temperatur");
  t.Menu( x+20, y+100, zeichen, 350, 20);

  sprintf  ( zeichen, "[C] schreiben des Configuration Register");
  t.Menu( x+20, y+120, zeichen, 350, 20);

  sprintf  ( zeichen, "[A] Lesen des Configuration Register");
  t.Menu( x+20, y+140, zeichen, 350, 20);

  sprintf  ( zeichen, "[O] Schreiben auf LCD und messen");
  t.Menu( x+20, y+160, zeichen, 350, 20);

  sprintf  ( zeichen,"Beenden mit [ESC] " );
  t.Menu( x+20, y+180, zeichen, 350, 20);

  setcolor(RED);
  sprintf  ( zeichen, "Thanks for using our Temperature Messurement");
  outtextxy( x, y+300, zeichen);

  //************************* CASES ***************************

  wahl=getch();
  switch(wahl)
  {
   case 'r': {     //************* Case Read Temperature *****************
		 do
		 {
		  cleardevice();
		  setcolor( RED );

		  outtextxy(150,30,"Temperaturmessung mit dem PC ");
		  outtextxy(170,40,"Temperatur einlesen");
		  outtextxy(150,50,"(Z)opyright by Martinjak & Pippan ");

		  t.Write_Port(Control,0x0F); //CLK auf HIGH Der REST auf NULL
		  delay( ws );
		  t.Write_Port(Control,0x0D); //drive RST high

		  //**************** Start Convert ********************

		  t.Send_Protocol( 180, 120, 0xEE, o, 1 );

		  //**************** Toggle RST ***********************

		  t.Write_Port( Control,0x0D );
		  outportb( Control,0x0F );
		  delay( 12 );
		  t.Write_Port( Control,0x0D );

		  //*********** Send Read Temperature Protocol ********

		  t.Send_Protocol( 180, 220, 0xAA, o, 1); //sends the Protocol 0xAA

		  //*************** Import Temperature ****************

		  t.Import_Temperatur( 180, 320, n, 1);   //Import the Temperature from the DS1620
		  setcolor( BLUE );

		  //*************** Temperature Output ****************

		  t.Temperatur_Ausgabe( 200, 400);

		  t.Write_Port( Control,0x0D );
		  outportb( Control,0x0F );
		  delay( 12 );
		  t.Write_Port( Control,0x0D );

		  outtextxy( 150, 450, "Programm beenden mit [ESC]");

		 }while(getch() != 27 );
		 break;
		 }

	case 'o':{
		  char buf[40];

		  cleardevice();
		  //************* Case Read Temperature *****************
		  do
		  {
		   setcolor( RED );

		   outtextxy(150,30,"Temperaturmessung mit dem PC ");
		   outtextxy(170,40,"Temperatur einlesen");
		   outtextxy(150,50,"(Z)opyright by Martinjak & Pippan ");

		   t.Write_Port( Control,0x0F); //CLK auf HIGH
		   delay( ws );
		   t.Write_Port(Control,0x0D); //drive RST high

		  //**************** Start Convert ********************

		   t.Send_Protocol( 400, 120, 0xEE, o, 1 ); // (x,y,Protocol,length,on/off);18i?#?#

		  //**************** Toggle RST ***********************

		   t.Write_Port( Control, 0x0D );
		   outportb( Control,0x0F );
		   delay( 12 );
		   t.Write_Port( Control,0x0D );

		  //*********** Send Read Temperature Protocol ********

		   t.Send_Protocol( 400, 220, 0xAA, o, 1);

		  //*************** Import Temperature ****************

		   t.Import_Temperatur( 400, 320, n, 1);   //Import the Temperature from the DS1620

		   setcolor( YELLOW );

		   t.Temperatur_Ausgabe(100,100);//+i*20);

		  //*************** Temperature Output ****************

		   t.Write_Port( Control,0x0D );
		   outportb( Control,0x0F );
		   delay( 12 );
		   t.Write_Port( Control,0x0D );

		   outtextxy( 150, 450, "Programm beenden mit [Q]uit");
		   }while(!kbhit());
		   break;
		 }

   case 'c': {   //************** Case Configuration Register **********

		cleardevice();
		setcolor( RED );

		outtextxy(180,30,"Temperaturmessung mit dem PC ");
		outtextxy(200,40,"Configurationsregister schreiben");
		outtextxy(180,50,"(Z)opyright by Martinjak & Pippan ");

		t.Write_Port( Control,0x0F); //CLK auf HIGH Der REST auf NULL
		delay( ws );
		t.Write_Port(Control,0x0D); //drive RST high

		t.Send_Protocol( 180, 120, 0x0C, o, 1 );
		t.Send_Protocol( 180, 220, 0x8A, o, 1 );

		t.Write_Port( Control,0x0D );
		outportb( Control,0x0F );
		delay( 15 );
		t.Write_Port( Control,0x0D );

		outtextxy( 150, 450, "Zurück durch Tastendruck");
		getch();

		break;
	     }

   case 'a': {     //************* Case Read Temperature *****************
		 do
		 {
		  cleardevice();
		  setcolor( RED );

		  outtextxy(150,30,"Temperaturmessung mit dem PC ");
		  outtextxy(170,40,"Configuration Register einlesen");
		  outtextxy(150,50,"(Z)opyright by Martinjak & Pippan ");

		  t.Write_Port( Control,0x0F); //CLK auf HIGH Der REST auf NULL
		  delay( ws );
		  t.Write_Port(Control,0x0D); //drive RST high

		  //*********** Send Read Configuration Protocol ********

		  t.Send_Protocol( 180, 120, 0xAC, o, 1);

		  //*************** Import Temperature ****************

		  t.Import_Temperatur( 180, 220, n, 1);   //Import the Temperature from the DS1620
		  setcolor( BLUE );

		  t.Write_Port( Control,0x0D );
		  outportb( Control,0x0F );
		  delay( 12 );
		  t.Write_Port( Control,0x0D );

		  outtextxy( 150, 450, "Programm beenden mit [ESC]");

		 }while(getch() != 27 );
		 break;
	     }
   }
 }while(getch() != 27);
}

 //********************** Kon- Destruktor *************************

INITDS::INITDS()
{
 int modus, karte = DETECT;
 initgraph( &karte, &modus,"g:\\dosprog\\borlandc\\bgi"); //"c:\\tc\\bgi" );

 cleardevice();
 setbkcolor( 7 );
 setcolor(RED);
}

INITDS::~INITDS()
{
 getch();
 closegraph();
}

//******************* Send Protocol Function ************************

void INITDS::Send_Protocol( int x, int y, unsigned char z, int d, int set)
{
 //**************************** set BIT 0-7 **************************
 unsigned char p, u, r;
 char buf[80];

 setcolor( BLUE );
 if(set==1)
 {
  sprintf( buf, "Send Protocol 0x%x ", z);
  outtextxy( x-40 ,y-30,buf );
  Rahmen( x, y, WHITE ,d );
 }

 Write_Port( Control,0x09 ); // drive CLK low

 for( int i=0; i<o; i++ )
	{
	 u=(~((z>>i) & 0x01))&0x01;

	 p = ( 0x08 |  u  );  // CLK low
	 Write_Port( Control, p );        // writes Protocol

	 if(set==1) SetKastl( x, y,(~p) & 0x01, i);  // put a Kastl
	 Write_Port( Control, u );

	 Write_Port( Control,0x0D ); // drive CLK high
	 Write_Port( Control,0x09 ); // drive CLK low

	}
  //*********************** PROTOCOL END ***************************

}

//************************** Import Temperature ***********************

void INITDS::Import_Temperatur(int x, int y, int d, int set)
{
 int i;
 unsigned int p=0,r=0,u;

 setcolor( BLUE );

 if(set==1)
 {
  Rahmen( x, y, WHITE, d);
  setcolor(BLUE);
  outtextxy(x-40 ,y-30,"Import Temperatur" );
 }
 Write_Port( Control, 0x01 );//0x01

 if(set==1) Rahmen( x, y, WHITE, d);

 for( i=0; i<n; i++ )
	{
	  p = inportb( Status ) & 0x20;  //reads the contents of the Port

	  Write_Port( Control, 0x01 );   //0x01 clk low

	  u = (( p >> 5 ) & 0x01);

	  if(set==1)SetKastl( x, y, ( u ), i );    // put a Kastl

	  Write_Port( Control, 0x05 );   //clk high
	  Write_Port( Control, 0x05 );   // drive CLK high
	  Write_Port( Control, 0x01 );   // drive CLK low

	  r = r | (u<<i);
	}

 Minusgrade(r);
 }

void INITDS::Menu(int x, int y, char *zeichen, int xm, int ym)
{
 setcolor(BLACK);
 setfillstyle( 1, GREEN );
 bar(x+4,y+4,x+4+xm,y+ym+4);

 setcolor(WHITE);
 setfillstyle( 1, WHITE );
 bar(x,y,x+xm,y+ym);
 setcolor( GREEN );
 outtextxy(x+6,y+6,zeichen);
}

void INITDS::Minusgrade( unsigned int r)
{
 unsigned int b;
 int t;
 b=(r >> 8) & 0x01;
 if(b==1)
 {
  r=(((~r)+1) & 0x00FF);
  in=int_to_double( r );
  in*=-1;
  Vorzeichen=0x40;
 }
 else
 {
  in=int_to_double( r );   //unsigned int to float
  Vorzeichen=0x00;
 }
 bin=in;
}

float INITDS::int_to_double( unsigned int Value)
{
 float Tmp;
 Tmp=(( float )( Value & 0x00FF ))/2;
 return Tmp;
}

void INITDS::Write_Port( unsigned int Port ,unsigned char i )
{
 outportb( Port, i );//| 0x2);
 delay( ws );
}

void INITDS::Temperatur_Ausgabe( int x, int y)
{
 char buf[40];

 setcolor( 7 );
 setfillstyle( 1, 7 );
 bar(x-80,y+40,x+220,y+250);

 setcolor(YELLOW);

 settextstyle( 10, 0, 5 );
 sprintf( buf, "%3.1f?C", in );
 outtextxy( x-25, y+50, buf );

 LCD_Ausgabe( in );

 settextstyle( 7, 0, 3 );
 sprintf( buf, "gemessene Temperatur:", in );
 outtextxy( x-70, y, buf );

 settextstyle( 0, 0, 1);

}

void INITDS::Rahmen(int x, int y, int c, int e)  //macht eine schönen weisen Rahmen
{
 setcolor( c );
 setfillstyle( 1, c );
 bar( x, y, x+e*20+5, y+40 );

 outtextxy( x, y-15, "LSB" );
 outtextxy( x+e*20-20, y-15, "MSB" );
 outtextxy( x-40, y+10, "WERT" );
 outtextxy( x-40, y+23, "BIT" );
}

void INITDS::SetKastl( int x, int y, unsigned char p, int i)
{//setzt die Bits
 int c;
 char zeichen[80];

 if( p==1 )
 {
  c=GREEN;

  Kastl( x+5+i*20, y+5, c );

  setcolor( WHITE );
  outtextxy( x+10+i*20, y+10, "1" );

  sprintf( zeichen,"%i",i );
  outtextxy( x+10+i*20, y+23, zeichen );
 }

 if( p==0 )
 {
  c=RED;

  Kastl( x+5+i*20, y+5, c );

  setcolor( WHITE );
  outtextxy( x+10+i*20, y+10, "0" );

  sprintf( zeichen,"%i",i );
  outtextxy( x+10+i*20, y+23, zeichen );

 }
}

void INITDS::Kastl( int x, int y, int c)
{
 setfillstyle( 1, c );
 bar(x,y,x+15,y+30);
}

void INITDS::LCD_Ausgabe( float u )
{
 int links=0,rechts=0,Vorzeichen=0,Komma=0;
 float i;

 if(u<0)Vorzeichen =0x80;
 if(u>=0)Vorzeichen=0x00;

 links = u/10;
 rechts = u-links*10;
 rechts=(int)rechts;
 i=u-(int)u;


 if(i==0)Komma=0x00;
 if(i==0.5)Komma=0x20;

 links = links | 0x10;
 outportb( Data, ( rechts | Vorzeichen | Komma ));
 delay(3);
 outportb( Data, ( links  | Vorzeichen | Komma ));
 delay(3);
}